package org.yaoqiang.util;

import java.awt.Cursor;
import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Locale;
import java.util.Properties;

import javax.swing.ImageIcon;

/**
 * Constants
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class Constants {

	/**
	 * VERSION
	 */
	public static final String VERSION = "2.1.9";

	/**
	 * SETTINGS
	 */
	public static Properties SETTINGS = new Properties();
	
	/**
	 * OS
	 */
	public static final String OS = System.getProperty("os.name");

	/**
	 * OS
	 */
	public static final Double JAVA_VERSION = Double.valueOf(System.getProperty("java.specification.version"));

	/**
	 * LOCALE
	 */
	public static Locale LOCALE = Locale.getDefault();

	/**
	 * YAOQIANG_USER_HOME
	 */
	public static final String YAOQIANG_USER_HOME = System.getProperty("user.home") + File.separator + ".yaoqiang";

	/**
	 * YAOQIANG_CONF_FILE
	 */
	public static final String YAOQIANG_CONF_FILE = "conf.properties";

	/**
	 * DF
	 */
	public static final SimpleDateFormat DF = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	/**
	 * DEFAULT_STYLE_XML
	 */
	public static final String DEFAULT_STYLE_XML = "/org/yaoqiang/graph/styles/default-style.xml";

	/**
	 * SHAPE_MARKER
	 */
	public static final String SHAPE_MARKER = "/org/yaoqiang/graph/shape/markers/";

	/**
	 * STYLE_KEYWORDS
	 */
	public static final String[] STYLE_KEYWORDS = { "expression", "loop", "loopImage", "compensation", "compensationImage" };

	/**
	 * HAND_CURSOR
	 */
	public static Cursor HAND_CURSOR = new Cursor(Cursor.HAND_CURSOR);

	/**
	 * DEFAULT_CURSOR
	 */
	public static Cursor DEFAULT_CURSOR = new Cursor(Cursor.DEFAULT_CURSOR);

	/**
	 * ICON_ARROW_DOWN
	 */
	public static ImageIcon ICON_ARROW_DOWN = new ImageIcon(Constants.class.getResource("/org/yaoqiang/collaboration/images/arrow_down.png"));

	/**
	 * ICON_ARROW_RIGHT
	 */
	public static ImageIcon ICON_ARROW_RIGHT = new ImageIcon(Constants.class.getResource("/org/yaoqiang/collaboration/images/arrow_right.png"));

	/**
	 * LOGO_ICON
	 */
	public static ImageIcon LOGO_ICON = new ImageIcon(Constants.class.getResource("/org/yaoqiang/graph/images/logo.png"));

	/**
	 * ATTACHMENT_ICON
	 */
	public static ImageIcon ATTACHMENT_ICON = new ImageIcon(Constants.class.getResource("/org/yaoqiang/graph/images/attachment.png"));

	/**
	 * ROLE_ICON
	 */
	public static ImageIcon ROLE_ICON = new ImageIcon(Constants.class.getResource("/org/yaoqiang/graph/images/marker_role.gif"));

	/**
	 * GROUP_ICON
	 */
	public static ImageIcon GROUP_ICON = new ImageIcon(Constants.class.getResource("/org/yaoqiang/graph/images/marker_group.png"));

	/**
	 * COMPANY_ICON
	 */
	public static ImageIcon COMPANY_ICON = new ImageIcon(Constants.class.getResource("/org/yaoqiang/graph/images/marker_company.png"));

	/**
	 * LDAP_ROOT_ICON
	 */
	public static ImageIcon LDAP_ROOT_ICON = new ImageIcon(Constants.class.getResource("/org/yaoqiang/graph/images/marker_ldaproot.png"));

	/**
	 * OU_ICON
	 */
	public static ImageIcon OU_ICON = new ImageIcon(Constants.class.getResource("/org/yaoqiang/graph/images/marker_organization.png"));

	/**
	 * USER_ICON
	 */
	public static ImageIcon USER_ICON = new ImageIcon(Constants.class.getResource("/org/yaoqiang/graph/shape/markers/task_user.png"));

	// --------------------WIDTH,SIZE--------------------//
	/**
	 * PAGE_WIDTH
	 */
	public static double PAGE_WIDTH = 11.7 * 72;

	/**
	 * PAGE_HEIGHT
	 */
	public static double PAGE_HEIGHT = 8.3 * 72;

	/**
	 * SWIMLANE_START_POINT
	 */
	public static int SWIMLANE_START_POINT = 50;

	/**
	 * SWIMLANE_WIDTH
	 */
	public static int SWIMLANE_WIDTH = 990;

	/**
	 * SWIMLANE_HEIGHT
	 */
	public static int SWIMLANE_HEIGHT = 700;

	/**
	 * SWIMLANE_SIZE
	 */
	public static int SWIMLANE_SIZE = 200;

	/**
	 * ACTIVITY_WIDTH
	 */
	public static final int ACTIVITY_WIDTH = 85;

	/**
	 * ACTIVITY_HEIGHT
	 */
	public static final int ACTIVITY_HEIGHT = 55;

	/**
	 * FOLDED_SUBPROCESS_WIDTH
	 */
	public static final int FOLDED_SUBPROCESS_WIDTH = 120;

	/**
	 * FOLDED_SUBPROCESS_HEIGHT
	 */
	public static final int FOLDED_SUBPROCESS_HEIGHT = 90;

	// ----------------------------ARROW--------------------------//
	/**
	 * ARROW_STYLE_OPEN_BLOCK
	 */
	public static final String ARROW_STYLE_OPEN_BLOCK = "open_block";

	/**
	 * ARROW_STYLE_OPEN_OVAL
	 */
	public static final String ARROW_STYLE_OPEN_OVAL = "open_oval";

	/**
	 * ARROW_STYLE_OPEN_DIAMOND
	 */
	public static final String ARROW_STYLE_OPEN_DIAMOND = "open_diamond";

	/**
	 * ARROW_STYLE_SLASH
	 */
	public static final String ARROW_STYLE_SLASH = "slash";

	/**
	 * RECTANGLE_ARCSIZE
	 */
	public static final int RECTANGLE_ARCSIZE = 13;

	// --------------------------SHAPE--------------------------//
	/**
	 * SHAPE_CONNECTOR
	 */
	public static final String SHAPE_CONNECTOR = "connector";

	/**
	 * SHAPE_ANNOTATION
	 */
	public static final String SHAPE_ANNOTATION = "annotation";

	/**
	 * SHAPE_DATAOBJECT
	 */
	public static final String SHAPE_DATAOBJECT = "dataobject";

	/**
	 * SHAPE_GROUP
	 */
	public static final String SHAPE_GROUP = "group";

	/**
	 * SHAPE_DATASTORE
	 */
	public static final String SHAPE_DATASTORE = "datastore";

	/**
	 * SHAPE_EVENT
	 */
	public static final String SHAPE_EVENT = "event";

	/**
	 * SHAPE_GATEWAY
	 */
	public static final String SHAPE_GATEWAY = "gateway";

	/**
	 * SHAPE_SUBPROCESS
	 */
	public static final String SHAPE_SUBPROCESS = "subprocess";

	/**
	 * SHAPE_ACTIVITY
	 */
	public static final String SHAPE_ACTIVITY = "activity";

	/**
	 * SHAPE_PARTICIPANT_BAND
	 */
	public static final String SHAPE_PARTICIPANT_BAND = "participantBand";

	/**
	 * SHAPE_CONVERSATION_NODE
	 */
	public static final String SHAPE_CONVERSATION_NODE = "conversationNode";

	/**
	 * SHAPE_CONVERSATION_LINK
	 */
	public static final String SHAPE_CONVERSATION_LINK = "conversationLink";

	// --------------------------STYLE--------------------------//
	/**
	 * STYLE_TYPE
	 */
	public static String STYLE_TYPE = "type";

	/**
	 * WIDTH
	 */
	public static String WIDTH = "width";

	/**
	 * HEIGHT
	 */
	public static String HEIGHT = "height";

	/**
	 * STYLE_TRIGGER
	 */
	public static String STYLE_TRIGGER = "trigger";

	/**
	 * STYLE_CALL
	 */
	public static final String STYLE_CALL = "call";

	/**
	 * STYLE_LOOP_IMAGE
	 */
	public static final String STYLE_LOOP_IMAGE = "loopImage";

	/**
	 * STYLE_ADHOC_IMAGE
	 */
	public static final String STYLE_ADHOC_IMAGE = "adHocImage";

	/**
	 * STYLE_COMPENSATION_IMAGE
	 */
	public static final String STYLE_COMPENSATION_IMAGE = "compensationImage";

	/**
	 * STYLE_INSTANTIATE
	 */
	public static final String STYLE_INSTANTIATE = "instantiate";

	/**
	 * STYLE_POSITION
	 */
	public static final String STYLE_POSITION = "position";

	/**
	 * STYLE_BORDER
	 */
	public static final String STYLE_BORDER = "border";

	/**
	 * STYLE_AUTO
	 */
	public static final String STYLE_AUTO = "auto";

	/**
	 * SWIMLANE_TYPE_VERTICAL
	 */
	public static final String SWIMLANE_TYPE_VERTICAL = "vertical";

	/**
	 * DATAOBJECT_STYLE_INPUT
	 */
	public static final String DATAOBJECT_STYLE_INPUT = "input";

	/**
	 * DATAOBJECT_STYLE_OUTPUT
	 */
	public static final String DATAOBJECT_STYLE_OUTPUT = "output";

	// --------------------------GATEWAY--------------------------//
	/**
	 * GATEWAY_STYLE_EXCLUSIVE_DATA_BASED
	 */
	public static final String GATEWAY_STYLE_EXCLUSIVE = "exclusiveGateway";

	/**
	 * GATEWAY_STYLE_EXCLUSIVE_EVENT_BASED
	 */
	public static final String GATEWAY_STYLE_EVENT = "eventGateway";

	/**
	 * GATEWAY_STYLE_PARALLEL
	 */
	public static final String GATEWAY_STYLE_PARALLEL = "parallelGateway";

	/**
	 * GATEWAY_STYLE_INCLUSIVE
	 */
	public static final String GATEWAY_STYLE_INCLUSIVE = "inclusiveGateway";

	/**
	 * GATEWAY_STYLE_COMPLEX
	 */
	public static final String GATEWAY_STYLE_COMPLEX = "complexGateway";

	// --------------------------SUBPROCESS--------------------------//
	/**
	 * SUBPROCESS_STYLE_EXPANDED_IMAGE
	 */
	public static final String SUBPROCESS_STYLE_EXPANDED_IMAGE = "expandedImage";

	/**
	 * SUBPROCESS_STYLE_TRANSACTION
	 */
	public static final String SUBPROCESS_STYLE_TRANSACTION = "transaction";

	/**
	 * SUBPROCESS_STYLE_EVENT
	 */
	public static final String SUBPROCESS_STYLE_EVENT = "event";

	/**
	 * SUBPROCESS_STYLE_ADHOC
	 */
	public static final String SUBPROCESS_STYLE_ADHOC = "adHoc";

	// --------------------------EVENT--------------------------//
	/**
	 * EVENT_STYLE_INTERMEDIATE
	 */
	public static final String EVENT_STYLE_INTERMEDIATE = "intermediate_event";

	// --------------------------SWIMLANE--------------------------//
	/**
	 * SWIMLANE_STYLE_LANE
	 */
	public static final String SWIMLANE_STYLE_LANE = "lane";

	// --------------------------ACTIVITY--------------------------//
	/**
	 * ACTIVITY_STYLE_LOOP_MI
	 */
	public static final String ACTIVITY_STYLE_LOOP_MI = "multi_instance";

	// ----------------------------FLOW--------------------------//
	/**
	 * FLOW_STYLE_STRAIGHT
	 */
	public static final String FLOW_STYLE_STRAIGHT = "straight";

	/**
	 * EDGE_TYPE_SEQUENCE_FLOW
	 */
	public static final String EDGE_TYPE_SEQUENCE_FLOW = "defaultEdge";

	/**
	 * EDGE_TYPE_ASSOCIATION
	 */
	public static final String EDGE_TYPE_ASSOCIATION = "association";

	/**
	 * EDGE_TYPE_CONVERSATION_LINK
	 */
	public static final String EDGE_TYPE_CONVERSATION_LINK = "conversationLink";

	/**
	 * EDGE_TYPE_MESSAGE_FLOW
	 */
	public static final String EDGE_TYPE_MESSAGE_FLOW = "messageFlow";

	/**
	 * EDGE_TYPE_DATA_ASSOCIATION
	 */
	public static final String EDGE_TYPE_DATA_ASSOCIATION = "dataAssociation";

	/**
	 * EDGE_TYPE_COMPENSATION_ASSOCIATION
	 */
	public static final String EDGE_TYPE_COMPENSATION_ASSOCIATION = "compensationAssociation";

	/**
	 * EDGE_TYPE_CONDITION_SEQUENCE_FLOW
	 */
	public static final String EDGE_TYPE_CONDITION_SEQUENCE_FLOW = "conditionFlow";

	/**
	 * EDGE_TYPE_DEFAULT_SEQUENCE_FLOW
	 */
	public static final String EDGE_TYPE_DEFAULT_SEQUENCE_FLOW = "defaultFlow";

	/**
	 * EDGE_TYPE_ORGANIZATION_FLOW
	 */
	public static final String EDGE_TYPE_ORGANIZATION_FLOW = "organizationFlow";

	/**
	 * POOL_SPACING
	 */
	public static int POOL_SPACING = 50;

	/**
	 * SWIMLANE_NAME_WIDTH
	 */
	public static final int SWIMLANE_NAME_WIDTH = 25;

	/**
	 * PARTICIPANT_HEIGHT
	 */
	public static final int PARTICIPANT_HEIGHT = 20;

	// ----------------------------VERTEX--------------------------//
	/**
	 * VERTEX_STYLE_DEFAULT
	 */
	public static final String VERTEX_STYLE_DEFAULT = "defaultVertex";

	/**
	 * TASK_STYLE_NO
	 */
	public static final String TASK_STYLE_NO = "no";

	/**
	 * ACTIVITY_STYLE_REFERENCE
	 */
	public static final String ACTIVITY_STYLE_REFERENCE = "actref";

	/**
	 * ACTIVITY_STYLE_LOOP_STANDARD
	 */
	public static final String ACTIVITY_STYLE_LOOP_STANDARD = "standard";

	/**
	 * ACTIVITY_STYLE_LOOP_MI_SEQUENTIAL
	 */
	public static final String ACTIVITY_STYLE_LOOP_MI_SEQUENTIAL = "multi_instance_sequential";

	/**
	 * ACTIVITY_STYLE_CHOREOGRAPHY
	 */
	public static final String ACTIVITY_STYLE_CHOREOGRAPHY = "choreography";

	/**
	 * ACTIVITY_STYLE_CHOREOGRAPHY
	 */
	public static final String ACTIVITY_STYLE_SUBCHOREOGRAPHY = "sub_choreography";

	/**
	 * ACTIVITY_STYLE_CHOREOGRAPHY_TASK
	 */
	public static final String ACTIVITY_STYLE_CHOREOGRAPHY_TASK = "choreography_task";

	/**
	 * ACTIVITY_STYLE_CHOREOGRAPHY_SUBPROCESS
	 */
	public static final String ACTIVITY_STYLE_CHOREOGRAPHY_SUBPROCESS = "choreography_subprocess";

	/**
	 * ACTIVITY_STYLE_CHOREOGRAPHY_PARTICIPANT
	 */
	public static final String ACTIVITY_STYLE_CHOREOGRAPHY_PARTICIPANT = "choreography_participant";

	// --------------------------TASK--------------------------//
	/**
	 * TASK_TYPE_SEND
	 */
	public static final String TASK_TYPE_SEND = "send";

	/**
	 * TASK_TYPE_RECEIVE
	 */
	public static final String TASK_TYPE_RECEIVE = "receive";

	/**
	 * TASK_TYPE_SERVICE
	 */
	public static final String TASK_TYPE_SERVICE = "service";

	/**
	 * TASK_TYPE_USER
	 */
	public static final String TASK_TYPE_USER = "user";

	/**
	 * TASK_TYPE_SCRIPT
	 */
	public static final String TASK_TYPE_SCRIPT = "script";

	/**
	 * TASK_TYPE_MANUAL
	 */
	public static final String TASK_TYPE_MANUAL = "manual";

	/**
	 * TASK_TYPE_BUSINESS_RULE
	 */
	public static final String TASK_TYPE_BUSINESS_RULE = "business_rule";

	/**
	 * EVENT_STYLE_START
	 */
	public static final String EVENT_STYLE_START = "start_event";

	/**
	 * EVENT_STYLE_END
	 */
	public static final String EVENT_STYLE_END = "end_event";

	/**
	 * STYLE_MESSAGE
	 */
	public static final String STYLE_MESSAGE = "message";

	/**
	 * STYLE_TIMER
	 */
	public static final String STYLE_TIMER = "timer";

	/**
	 * STYLE_ESCALATION
	 */
	public static final String STYLE_ESCALATION = "escalation";

	/**
	 * STYLE_CONDITIONAL
	 */
	public static final String STYLE_CONDITIONAL = "conditional";

	/**
	 * STYLE_LINK
	 */
	public static final String STYLE_LINK = "link";

	/**
	 * STYLE_ERROR
	 */
	public static final String STYLE_ERROR = "error";

	/**
	 * STYLE_CANCEL
	 */
	public static final String STYLE_CANCEL = "cancel";

	/**
	 * STYLE_SIGNAL
	 */
	public static final String STYLE_SIGNAL = "signal";

	/**
	 * STYLE_MULTIPLE
	 */
	public static final String STYLE_MULTIPLE = "multiple";

	/**
	 * STYLE_PARALLEL_MULTIPLE
	 */
	public static final String STYLE_PARALLEL_MULTIPLE = "parallelmultiple";

	/**
	 * STYLE_TERMINATE
	 */
	public static final String STYLE_TERMINATE = "terminate";

	/**
	 * STYLE_SUBTYPE
	 */
	public static final String STYLE_SUBTYPE = "subtype";

	/**
	 * STYLE_LOOP
	 */
	public static final String STYLE_LOOP = "loop";

	/**
	 * STYLE_COLLECTION
	 */
	public static final String STYLE_COLLECTION = "collection";

	/**
	 * STYLE_COMPENSATION
	 */
	public static final String STYLE_COMPENSATION = "compensation";

	/**
	 * STYLE_SOURCE
	 */
	public static final String STYLE_SOURCE = "source";

	/**
	 * STYLE_THROW
	 */
	public static final String STYLE_THROW = "throw";

	/**
	 * STYLE_INITIATING
	 */
	public static final String STYLE_INITIATING = "initiating";

	/**
	 * STYLE_INIT
	 */
	public static final String STYLE_INIT = "init";

	/**
	 * STYLE_EXPRESSION
	 */
	public static final String STYLE_EXPRESSION = "expression";

	/**
	 * STYLE_ORGANIZATION_NAME
	 */
	public static final String STYLE_ORGANIZATION_NAME = "organizationName";
	
	/**
	 * STYLE_ORGANIZATIONAL_ROOT
	 */
	public static final String STYLE_ORGANIZATIONAL_ROOT = "organizationRoot";

	/**
	 * STYLE_ORGANIZATION
	 */
	public static final String STYLE_ORGANIZATION = "organization";

	/**
	 * STYLE_ORGANIZATIONAL_PERSON
	 */
	public static final String STYLE_ORGANIZATIONAL_PERSON = "organizationalPerson";

	/**
	 * STYLE_ORGANIZATIONAL_UNIT
	 */
	public static final String STYLE_ORGANIZATIONAL_UNIT = "organizationalUnit";

	/**
	 * STYLE_ORGANIZATIONAL_ROLE
	 */
	public static final String STYLE_ORGANIZATIONAL_ROLE = "organizationalRole";

	/**
	 * STYLE_ORGANIZATIONAL_GROUP
	 */
	public static final String STYLE_ORGANIZATIONAL_GROUP = "groupOfNames";

	/**
	 * EVENT_LOOPTYPE_CHANGED
	 */
	public static final String EVENT_LOOPTYPE_CHANGED = "loopTypeChanged";

	/**
	 * EVENT_ATTR_CHANGED
	 */
	public static final String EVENT_ATTR_CHANGED = "attrChanged";

	/**
	 * ENTER_GROUP
	 */
	public static final String ENTER_GROUP = "enterGroup";
	
	/**
	 * EXIT_GROUP
	 */
	public static final String EXIT_GROUP = "exitGroup";

}
